/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _UNIONOFEVENTJOURNALTIMEZONETODO_H_
#define _UNIONOFEVENTJOURNALTIMEZONETODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class RecurrenceIdentifier;
    class NcalDateTime;

}

#include "unionparentclass.h"

namespace NepomukFast {


    class UnionOfEventJournalTimezoneTodo : public UnionParentClass
    {
    public:
        /**
         * Create a new empty and invalid UnionOfEventJournalTimezoneTodo instance
         */
        UnionOfEventJournalTimezoneTodo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'lastModified'. The property specifies the date 
         * and time that the information associated with the calendar 
         * component was last revised in the calendar store. Note: This 
         * is analogous to the modification date and time for a file in the 
         * file system. Inspired by RFC 2445 sec. 4.8.7.3. Note that the 
         * RFC allows ONLY UTC time values for this property. 
         */
        void setLastModifieds( const QList<QDateTime>& value );

        /**
         * Add a value to property 'lastModified'. The property specifies 
         * the date and time that the information associated with the calendar 
         * component was last revised in the calendar store. Note: This 
         * is analogous to the modification date and time for a file in the 
         * file system. Inspired by RFC 2445 sec. 4.8.7.3. Note that the 
         * RFC allows ONLY UTC time values for this property. 
         */
        void addLastModified( const QDateTime& value );

        /**
         * Set property 'lastModified'. The property specifies the date 
         * and time that the information associated with the calendar 
         * component was last revised in the calendar store. Note: This 
         * is analogous to the modification date and time for a file in the 
         * file system. Inspired by RFC 2445 sec. 4.8.7.3. Note that the 
         * RFC allows ONLY UTC time values for this property. 
         */
        void setLastModified( const QDateTime& value );

        /**
         * \return The URI of the property 'lastModified'. 
         */
        static QUrl lastModifiedUri();

        /**
         * Set property 'recurrenceId'. This property is used in conjunction 
         * with the "UID" and "SEQUENCE" property to identify a specific 
         * instance of a recurring "VEVENT", "VTODO" or "VJOURNAL" calendar 
         * component. The property value is the effective value of the 
         * "DTSTART" property of the recurrence instance. Inspired by 
         * the RFC 2445 sec. 4.8.4.4 
         */
        void setRecurrenceIds( const QList<RecurrenceIdentifier>& value );

        /**
         * Add a value to property 'recurrenceId'. This property is used 
         * in conjunction with the "UID" and "SEQUENCE" property to identify 
         * a specific instance of a recurring "VEVENT", "VTODO" or "VJOURNAL" 
         * calendar component. The property value is the effective value 
         * of the "DTSTART" property of the recurrence instance. Inspired 
         * by the RFC 2445 sec. 4.8.4.4 
         */
        void addRecurrenceId( const RecurrenceIdentifier& value );

        /**
         * Set property 'recurrenceId'. This property is used in conjunction 
         * with the "UID" and "SEQUENCE" property to identify a specific 
         * instance of a recurring "VEVENT", "VTODO" or "VJOURNAL" calendar 
         * component. The property value is the effective value of the 
         * "DTSTART" property of the recurrence instance. Inspired by 
         * the RFC 2445 sec. 4.8.4.4 
         */
        void setRecurrenceId( const RecurrenceIdentifier& value );

        /**
         * \return The URI of the property 'recurrenceId'. 
         */
        static QUrl recurrenceIdUri();

        /**
         * Set property 'exdate'. This property defines the list of date/time 
         * exceptions for a recurring calendar component. Inspired by 
         * RFC 2445 sec. 4.8.5.1 
         */
        void setExdates( const QList<NcalDateTime>& value );

        /**
         * Add a value to property 'exdate'. This property defines the 
         * list of date/time exceptions for a recurring calendar component. 
         * Inspired by RFC 2445 sec. 4.8.5.1 
         */
        void addExdate( const NcalDateTime& value );

        /**
         * \return The URI of the property 'exdate'. 
         */
        static QUrl exdateUri();



    protected:
        UnionOfEventJournalTimezoneTodo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
